clang 10.0.0git

Public Member Functions | Static Public Member Functions | Friends | List of all members
clang::SrcMgr::FileInfo Class Reference

Information about a FileID, basically just the logical file that it represents and include stack information. More...

`#include "clang/Basic/SourceManager.h"`

## Public Member Functions
SourceLocation | getIncludeLoc () const
const ContentCache * | getContentCache () const
CharacteristicKind | getFileCharacteristic () const
| Return whether this is a system header or not. More...
bool | hasLineDirectives () const
| Return true if this FileID has #line directives in it. More...
void | setHasLineDirectives ()
| Set the flag that indicates that this FileID has line table entries associated with it. More...
StringRef | getName () const
| Returns the name of the file that was used when the file was loaded from the underlying file system. More...

## Static Public Member Functions
static FileInfo | get (SourceLocation IL, const ContentCache *Con, CharacteristicKind FileCharacter, StringRef Filename)
| Return a FileInfo object. More...

## Friends
class | clang::SourceManager
class | clang::ASTWriter
class | clang::ASTReader

## Detailed Description

Information about a FileID, basically just the logical file that it represents and include stack information.

Each FileInfo has include stack information, indicating where it came from. This information encodes the #include chain that a token was expanded from. The main include file has an invalid IncludeLoc.

FileInfos contain a "ContentCache *", with the contents of the file.

Definition at line 249 of file SourceManager.h.

## Member Function Documentation

## ◆ get()

static FileInfo clang::SrcMgr::FileInfo::get | ( | SourceLocation | IL,
|  | const ContentCache * | Con,
|  | CharacteristicKind | FileCharacter,
|  | StringRef | Filename
| ) |  |
| inline static

Return a FileInfo object.

Definition at line 278 of file SourceManager.h.

References Filename, and X.

## ◆ getContentCache()

const ContentCache* clang::SrcMgr::FileInfo::getContentCache | ( |  | ) | const
| inline

Definition at line 294 of file SourceManager.h.

Referenced by emitBlob(), clang::SourceManager::getBuffer(), clang::SourceManager::getBufferData(), clang::SourceManager::getCharacterData(), clang::SourceManager::getFileEntryForID(), clang::SourceManager::getFileEntryForSLocEntry(), clang::SourceManager::getFileEntryRefForID(), clang::SourceManager::getLineNumber(), clang::SourceManager::getPresumedLoc(), clang::ASTImporter::Import(), clang::SourceManager::translateFile(), and clang::SourceManager::translateLineCol().

## ◆ getFileCharacteristic()

CharacteristicKind clang::SrcMgr::FileInfo::getFileCharacteristic | ( |  | ) | const
| inline

Return whether this is a system header or not.

Definition at line 299 of file SourceManager.h.

Referenced by emitBlob(), clang::SourceManager::getFileCharacteristic(), getNullabilityCompletenessCheckFileID(), clang::ASTImporter::Import(), clang::index::IndexingContext::importedModule(), and shouldReportOccurrenceForSystemDeclOnlyMode().

## ◆ getIncludeLoc()

SourceLocation clang::SrcMgr::FileInfo::getIncludeLoc | ( |  | ) | const
| inline

Definition at line 290 of file SourceManager.h.

References clang::SourceLocation::getFromRawEncoding().

Referenced by emitBlob(), clang::SourceManager::getDecomposedIncludedLoc(), clang::SourceManager::getIncludeLoc(), getNullabilityCompletenessCheckFileID(), clang::SourceManager::getPresumedLoc(), clang::ASTImporter::Import(), clang::SourceManager::isInMainFile(), and clang::SourceManager::translateLineCol().

## ◆ getName()

StringRef clang::SrcMgr::FileInfo::getName | ( |  | ) | const
| inline

Returns the name of the file that was used when the file was loaded from the underlying file system.

Definition at line 314 of file SourceManager.h.

References Filename.

Referenced by clang::SourceManager::getFileEntryRefForID().

## ◆ hasLineDirectives()

bool clang::SrcMgr::FileInfo::hasLineDirectives | ( |  | ) | const
| inline

Return true if this FileID has #line directives in it.

Definition at line 304 of file SourceManager.h.

Referenced by emitBlob(), clang::SourceManager::getFileCharacteristic(), clang::SourceManager::getPresumedLoc(), and clang::SourceManager::isInMainFile().

## ◆ setHasLineDirectives()

void clang::SrcMgr::FileInfo::setHasLineDirectives | ( |  | ) |
| inline

Set the flag that indicates that this FileID has line table entries associated with it.

Definition at line 308 of file SourceManager.h.

## Friends And Related Function Documentation

## ◆ clang::ASTReader

friend class clang::ASTReader
| friend

Definition at line 252 of file SourceManager.h.

## ◆ clang::ASTWriter

friend class clang::ASTWriter
| friend

Definition at line 251 of file SourceManager.h.

## ◆ clang::SourceManager

friend class clang::SourceManager
| friend

Definition at line 250 of file SourceManager.h.

The documentation for this class was generated from the following file:

- include/clang/Basic/SourceManager.h